#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_zap2verb4xi.py">
#<abstract4xi abstract = "tests zap2verb4xi.py"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<contextualize4xi context = "reason-xml files"/> 
#<use4xi usage = "
# BEFORE
#  > all2test4xi (produces the latest reason-xml files)
# ---------------------------------------------------------------------------------------------
# WARNING:  DO NOT TRY TO RUN TOO MANY IN THE SAME RUN - MIGHT REQUIRE TOO MUCH MEMORY !
#     TIP:  OPEN THREE (3) WINDOWS AND ZAP SCOPED SENSE, REASON AND ACE FILES IN THEIR OWN WINDOW     
# VERSION:  no dragon-trace in zap-modules + direction one having no dragon trace calls!
# REMEMBER: you need to have ALL the latest xml-files created & scoped, if you change source modules!
#    CHECK: use Studio4Xi program find4zap.py to check possible missing links to modules!
# ---------------------------------------------------------------------------------------------
#
# RUN
#  1) select a file in ZapKb4Xi
#  2) > call t test_zap2verb4xi > ..\txt\test_zap2verb4xi.txt <-- zap2verb4xi.bat
#"
#/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'test_zap2verb4xi',            
            'set_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi

from print4xi import Print4Xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi

from zap2verb4xi import command2verb4zap
from zap2verb4xi import ace_zap2verb4xi
from zap2verb4xi import reason_zap2verb4xi
from zap2verb4xi import sense_zap2verb4xi
from zap2verb4xi import zap2verb4xi
from zap2verb4xi import Zap2Verb4Xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global PickleKB4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi}
       
t2xi = Print4Xi()
        
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set_trace4xi" usage = "
#   creating Print4Xi object t2xi and setting trace by reading pickle2?4xi.py files
#">                      
# -------------------------------------------------------------------------------------------------    
def set_trace4xi():
    '''
    creating Print4Xi object t2xi and setting trace by reading pickle2?4xi.py files
    '''
    global t2xi 
    global PickleKB4Xi
    ack2debug = True
    
    
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33)
    # ---------------------------------------------------------------------------------------------
    try:
        t2xi = Print4Xi()
    except:
        print("(STEP 1Z/33) OF SET_TRACE4XI *** FAILED TO CREATE Print4Xi OBJECT ", time4xi())    

    try:
        # -------------------------------------------------------------------------------------
        # (STEP 2/33)
        # -------------------------------------------------------------------------------------
        keys2alpha = sorted(PickleKB4Xi.keys())
        if ack2debug is True:
            print("(STEP 2A/33) OF SET_TRACE4XI: KEYS2ALPHA SET TO: ", keys2alpha)                 # ['_', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']

 
        for key2alpha in keys2alpha:                                            
 
            # ---------------------------------------------------------------------------------    
            # (STEP 3/33)
            # ---------------------------------------------------------------------------------     
            kb2try = PickleKB4Xi[key2alpha]
            keys2try = sorted(kb2try.keys())
            # ---------------------------------------------------------------------------------    
            #
            # ---------------------------------------------------------------------------------     
            for key2try in keys2try:
                # -----------------------------------------------------------------------------    
                #                                                              
                # -----------------------------------------------------------------------------     
                t2xi.set_print_permission(key2try, kb2try[key2try])                                # _C, _MainProcess4Xi ... FOR PRINT4XI SET TO NACK4XI
    except:
        print("(STEP 2Z/33) OF SET_TRACE4XI *** FAILED TO SET TRACE *** ", time4xi())                  
                           

    # ---------------------------------------------------------------------------------------------
    # (STEP 4/33)
    # ---------------------------------------------------------------------------------------------

    return PickleKB4Xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny_trace4xi" usage = "
#   denying trace and creating trace knowledgebase for this module.
#">                      
# -------------------------------------------------------------------------------------------------    
def deny_trace4xi(kb2trace):
    '''
    denying trace and creating trace knowledgebase for this module.
    '''

    global t2xi
    ack2debug = True
    
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33)
    # ---------------------------------------------------------------------------------------------

    try:
        # -------------------------------------------------------------------------------------
        # (STEP 2/33)
        # -------------------------------------------------------------------------------------
        keys2alpha = sorted(kb2trace.keys())

        for key2alpha in keys2alpha:                                            
 
            # ---------------------------------------------------------------------------------    
            # (STEP 3/33)
            # ---------------------------------------------------------------------------------     
            kb2try = kb2trace[key2alpha]

            keys2try = sorted(kb2try.keys())
            # ---------------------------------------------------------------------------------    
            #
            # ---------------------------------------------------------------------------------     
            for key2try in keys2try:
                # -----------------------------------------------------------------------------    
                #                                                              
                # -----------------------------------------------------------------------------     
                t2xi.set_print_permission(key2try, 'ACK4XI')                                       # _C, _MainProcess4Xi ... FOR PRINT4XI SET TO ACK4XI

    except:
        print("(STEP 2Z/33) OF DENY_TRACE4XI *** FAILED TO DENY TRACE *** ", time4xi())                  
                           

    # ---------------------------------------------------------------------------------------------
    # (STEP 4/33)
    # ---------------------------------------------------------------------------------------------
        
    return kb2trace
            
#</function4xi> 
             

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor_trace4xi" usage = "
#   tailors trace  
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor_trace4xi(kb2trace):
    '''
    tailors trace
    '''
    ack2debug = True

    try:
        # -----------------------------------------------------------------------------------------
        # Tailoring trace
        # -----------------------------------------------------------------------------------------
        #<set4xi setting = "
        
        # -----------------------------------------------------------------------------------------
        # [p] - SYSTEM LEVEL TRACE
        # -----------------------------------------------------------------------------------------        
        key2alpha = 'p'
        kb2trace [key2alpha] ['Pipe4Xi']              = 'NACK4TRACE'
        kb2trace [key2alpha] ['Popen4Xi']             = 'NACK4TRACE'
        kb2trace [key2alpha] ['Process4Xi']           = 'NACK4TRACE'
        # -----------------------------------------------------------------------------------------
        # [q] - SYSTEM LEVEL TRACE
        # -----------------------------------------------------------------------------------------         
        key2alpha = 'q'
        kb2trace [key2alpha] ['Queue4Xi4Xi']          = 'NACK4TRACE'
        # -----------------------------------------------------------------------------------------
        # [z] - APPLICATION LEVEL TRACE - SET TRACE ONLY TO LAYER 0000 AND 0010 FOR EXAMPLE
        # ----------------------------------------------------------------------------------------- 
        key2alpha = 'z'        
        kb2trace [key2alpha] ['zap2verb4xi2test']     = 'NACK4TRACE'  # MAIN MODULES
        kb2trace [key2alpha] ['Zap2Verb4Xi2test']     = 'NACK4TRACE'
        kb2trace [key2alpha] ['zap2verb4xi2test']     = 'ACK4TRACE'
        kb2trace [key2alpha] ['Zap2Noun4Xi2test']     = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2verb4xi2test']     = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2Verb4xi2test']     = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000one4xi2test']   = 'ACK4TRACE'  # DIRECTION ONE 
        kb2trace [key2alpha] ['zap0001one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200one4xi2test']   = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300one4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000two4xi2test']   = 'ACK4TRACE'  # DIRECTION TWO         
        kb2trace [key2alpha] ['zap0001two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200two4xi2test']   = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300two4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000three4xi2test'] = 'ACK4TRACE'  # DIRECTION THREE        
        kb2trace [key2alpha] ['zap0001three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200three4xi2test'] = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300three4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000four4xi2test']  = 'ACK4TRACE'  # DIRECTION FOUR        
        kb2trace [key2alpha] ['zap0001four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200four4xi2test']  = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300four4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000five4xi2test']  = 'ACK4TRACE'  # DIRECTION FIVE        
        kb2trace [key2alpha] ['zap0001five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200five4xi2test']  = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300five4xi2test']  = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000six4xi2test']   = 'ACK4TRACE'  # DIRECTION SIX        
        kb2trace [key2alpha] ['zap0001six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200six4xi2test']   = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300six4xi2test']   = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000seven4xi2test'] = 'ACK4TRACE'  # DIRECTION SEVEN        
        kb2trace [key2alpha] ['zap0001seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200seven4xi2test'] = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300seven4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0000eight4xi2test'] = 'ACK4TRACE'  # DIRECTION EIGHT        
        kb2trace [key2alpha] ['zap0001eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0010eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0100eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0200eight4xi2test'] = 'ACK4TRACE'  
        kb2trace [key2alpha] ['zap0300eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0400eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0500eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0600eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0700eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0800eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap0900eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1000eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1100eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1200eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1300eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1400eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1500eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1600eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1700eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1800eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap1900eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2000eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2100eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2200eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2300eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2400eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2500eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2600eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2700eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2800eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap2900eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3000eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3100eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3200eight4xi2test'] = 'ACK4TRACE'
        kb2trace [key2alpha] ['zap3300eight4xi2test'] = 'ACK4TRACE'
        # -----------------------------------------------------------------------------------------
        # [_]
        # -----------------------------------------------------------------------------------------         
        key2alpha = '_'
        kb2trace [key2alpha] ['_MainProcess4Xi']  = 'NACK4TRACE'
        
        print("(STEP 1B/33) OF TAILOR_TRACE4XI - TAILORED TRACE ", time4xi())
        
        #"/>
    except:
        print("(STEP 1C/33) OF TAILOR_TRACE4XI *** FAILED TO TAILOR TRACE *** ", time4xi())
        

    return kb2trace    
#</function4xi>


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\reason-zap2verb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n'}
    try:  
        xml_trace_sense4xi(t2xi, context2sense)
    except:
        pass    

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-zap2verb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
    
    try:   
        xml_trace_reason4xi(t2xi, context2reason)
    except:
        pass   
        
    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\reason-zap2verb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Zap2Verb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    try: 
        xml_trace_ace4xi(t2xi, context2ace)
    except:
        pass   

    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-zap2verb4xi" usage = "
#   reads scope-reason-xml-files files and creates zap-scope-reason-xml-files
#   for example: reads scope-reason-zap2verb4xi.xml and creates zap-scope-reason-zap2verb4xi.xml  
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_zap2verb4xi():
    global t2xi 
    # ---------------------------------------------------------------------------------------------
    # WARNING:  DO NOT TRY TO RUN TOO MANY IN THE SAME RUN - MIGHT REQUIRE TOO MUCH MEMORY !
    #     TIP:  OPEN THREE (3) WINDOWS AND ZAP SCOPED SENSE, REASON AND ACE FILES IN THEIR OWN WINDOW     
    # VERSION:  no dragon-trace in zap-modules + direction one having no dragon trace calls!
    # REMEMBER: you need to have ALL the latest xml-files created & scoped, if you change source modules!
    #    CHECK: use Studio4Xi program find4zap.py to check possible missing links to modules!
    # ---------------------------------------------------------------------------------------------
             
    ZapKb4Xi = {                                                            # REMEMBER: nack = ZAP IT !
       '..//..//xml//scope-reason-all-methods4xi.xml': 'ack',               # OK 
       '..//..//xml//scope-reason-test-arena4xi.xml': 'ack',                     # SKIP - SKELETON!
       '..//..//xml//scope-reason-ctypes4xi.xml': 'ack',                    # OK 
       '..//..//xml//scope-reason-current-process4xi.xml': 'ack',           # OK 
       '..//..//xml//scope-reason-dummy-process4xi.xml': 'ack',             # OK 
       '..//..//xml//scope-reason-finalize4xi.xml': 'ack',                  # OK 
       '..//..//xml//scope-reason-hello-pipe4xi.xml': 'ack',                # OK 
       '..//..//xml//scope-reason-hello-world4xi.xml': 'ack',               # OK                       
       '..//..//xml//scope-reason-zap2verb4xi.xml': 'ack',                  # SKIP - SKELETON!                 
       '..//..//xml//scope-reason-math-two-4xi.xml': 'ack',                 # SKIPPED 
       '..//..//xml//scope-reason-math4xi.xml': 'ack',                      # OK
       '..//..//xml//scope-reason-pickle4xi.xml': 'ack',                    # OK
       '..//..//xml//scope-reason-pipe1-test4xi.xml': 'ack',                # OK 
       '..//..//xml//scope-reason-pool-one-4xi.xml': 'ack',                 # OK 
       '..//..//xml//scope-reason-processref4xi.xml': 'ack',                # OK 
       '..//..//xml//scope-reason-proxy-mp-test4xi.xml': 'ack',             # OK
       '..//..//xml//scope-reason-public-methods-test4xi.xml': 'ack',       # OK  
       '..//..//xml//scope-reason-server4xi.xml': 'ack',                    # SKIP - SKELETON!  
       '..//..//xml//scope-reason-shared-ctypes4xi.xml': 'ack',             # SKIPPED  
       '..//..//xml//scope-reason-sleep4xi.xml': 'ack',                     # SKIP - SKELETON!
       '..//..//xml//scope-reason-sync-manager-test4xi.xml': 'ack',         # OK  
       '..//..//xml//scope-reason-test-after_fork4xi.xml': 'ack',           # OK 
       '..//..//xml//scope-reason-test-arena4xi.xml': 'ack',                # OK 
       '..//..//xml//scope-reason-test-ball4xi.xml': 'ack',                 # SKIP - Utility M1 profile  SKIP - SKELETON! 
       '..//..//xml//scope-reason-test-benchmark4xi.xml': 'ack',            # SKIP - SKELETON!
       '..//..//xml//scope-reason-test-constant-connection4xi.xml': 'ack',  # OK 
       '..//..//xml//scope-reason-test-constant-family4xi.xml': 'ack',      # OK 
       '..//..//xml//scope-reason-test-constant-forking4xi.xml': 'ack',     # OK 
       '..//..//xml//scope-reason-test-constant-heap4xi.xml': 'ack',        # OK
       '..//..//xml//scope-reason-test-constant-logger4xi.xml': 'ack',      # OK
       '..//..//xml//scope-reason-test-constant-managers4xi.xml': 'ack',    # OK
       '..//..//xml//scope-reason-test-constant-pool4xi.xml': 'ack',        # OK 
       '..//..//xml//scope-reason-test-constant-process4xi.xml': 'ack',     # OK     
       '..//..//xml//scope-reason-test-constant-synchronize4xi.xml': 'ack', # OK 
       '..//..//xml//scope-reason-test-constant-system4xi.xml': 'ack',      # OK  
       '..//..//xml//scope-reason-test-constant-util4xi.xml': 'ack',        # OK
       '..//..//xml//scope-reason-test-cpu-corecount4xi.xml': 'ack',        # OK       
       '..//..//xml//scope-reason-test-format4xi.xml': 'ack',               # OK
       '..//..//xml//scope-reason-test-kskeleton4xi.xml': 'ack',            # OK
       '..//..//xml//scope-reason-test-locks4xi.xml': 'ack',                # SKIP - SKELETON!
       '..//..//xml//scope-reason-test-logger4xi.xml': 'ack',               # OK
       '..//..//xml//scope-reason-test-manager4xi.xml': 'ack',              # OK
       '..//..//xml//scope-reason-test-original-dir4xi.xml': 'ack',         # OK
       '..//..//xml//scope-reason-test-server4xi.xml': 'ack',               # OK
       '..//..//xml//scope-reason-test-shared-ctypes4xi.xml': 'ack',        # OK 
       '..//..//xml//scope-reason-test-skeleton-print4xi.xml': 'ack',       # OK         
       '..//..//xml//scope-reason-test-sphere4xi.xml': 'ack',               # OK - Module Tester M1 Sphere - trace minimized
       '..//..//xml//scope-reason-test-state4xi.xml': 'ack',                # OK
       '..//..//xml//scope-reason-test-uskeleton4xi.xml': 'ack',            # OK            
       '..//..//xml//scope-reason-test-yskeleton4xi.xml': 'ack',            # OK
       '..//..//xml//scope-reason-test-zskeleton4xi.xml': 'ack',            # OK - Default 
       '..//..//xml//scope-reason-timeout4xi.xml': 'ack',                   # SKIP - SKELETON!
       '..//..//xml//scope-reason-token4xi.xml': 'ack',                     # SKIP - SKELETON!
       '..//..//xml//scope-reason-value-proxy4xi.xml': 'ack',               # OK
       '..//..//xml//scope-reason-value-test4xi.xml': 'nack'}                # OK 
                                                                            # all run 7th of April 2014        

    #  TIP: sometimes bottom-up approach and running only one may work better
    #       if you select several the order in which it will execute might be surprise to you!       


    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)
    print('=' *33)          
    print('(STEP 1A/33) OF TEST_ZAP2VERB4XI: STARTING ', time4xi())         # 
    
    kb2trace = set_trace4xi()                                                # read trace knowledgebase from pickle2?4xi.py modules
    print('(STEP 1B/33) OF TEST_ZAP2VERB4XI: PERFORMED set_trace4xi: ', time4xi())    
    
                                                                        
    kb2trace = deny_trace4xi(kb2trace)                                       # deny trace in for all classes and functions in the system
    print('(STEP 1C/33) OF TEST_ZAP2VERB4XI: PERFORMED deny_trace4xi: ', time4xi())
    
    
    kb2trace = tailor_trace4xi(kb2trace)                                     # tailor trace for this module
    print('(STEP 1C/33) OF TEST_ZAP2VERB4XI: PERFORMED tailor_trace4xi: ', time4xi())
      

    print("(STEP 1C/33) OF TEST_ZAP2VERB4XI:  TRYING TO EXPLORE POTENTIAL FILES FOR ZAPPING") 
      
    len2kb= len(ZapKb4Xi)
    
    print("(STEP 2/33) OF TEST_ZAP2VERB4XI: MAX NUMBER OF SCOPE-XML FILES TO BE CHECKED - LEN2KB: ", len2kb) 
    keys2kb = ZapKb4Xi.keys()                                                                                       # 55 
        
    # ---------------------------------------------------------------------------------------------
    # ZAP NOT YET ZAPPED ONES
    # --------------------------------------------------------------------------------------------- 
    for key2kb in sorted(keys2kb):                                          
        # print("(STEP 3/33) OF TEST_ZAP2VERB4XI: CHECKING ZAP-STATUS OF FILE: ", key2kb)  
            
        if ZapKb4Xi[key2kb] == 'nack':
            print("(STEP 4/33) OF TEST_ZAP2VERB4XI: TRYING TO ZAP FROM INPUT FILE: ", key2kb)                      # ..//..//xml//scope-reason-test-zskeleton4xi.xml
            # -------------------------------------------------------------------------------------
            # ZAP 
            # -------------------------------------------------------------------------------------             
            try:
                t2xi = Print4Xi()                                                                                   # initialize to save memory
                
                zap2verb4xi(key2kb)                                                                                # zap 
         
                print("(STEP 5/33) OF TEST_ZAP2VERB4XI: ZAPPED FROM INPUT FILE: ", key2kb)
            except:
                print("(STEP 6/33) OF TEST_ZAP2VERB4XI *** FAILED TO ZAP FROM INPUT FILE: ", key2kb)   
        else:
            # print("(STEP 7/33) OF TEST_ZAP2VERB4XI: SKIPPED ALREADY ZAPPED FILE: ", key2kb)
            pass
                
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 8/33) OF TEST_ZAP2VERB4XI: ZAPPED ALL SCOPE-XML-FILES ", time4xi()) 
         
    ack2trace = False                                                                                               # normal and/or dragonized trace                                                                            
    if ack2trace is True:
        try:  
            # -----------------------------------------------------------------------------------------    
            # Print Trace
            # -----------------------------------------------------------------------------------------     
            print("(STEP 9/33) OF TEST_ZAP2VERB4XI: CALLING PRINT_TRACE4XI ", time4xi()) 
        
            print_trace4xi(t2xi)
                                      
            print("(STEP 10/33) OF TEST_ZAP2VERB4XI: PERFORMED PRINT_TRACE4XI ", time4xi())
                
        except:
            pass
    else:
        pass
                    
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(STEP 33/33) OF TEST_ZAP2VERB4XI: DONE!', time4xi())
    print('=' *33)
        
   
         
       
#</function4xi>
     

                   
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for test_zap2verb4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("ZAPPING IT WITH YOURDRAGONXI ", time4xi())  
    print('=' *33)
        
    test_zap2verb4xi()    
    
    print('=' *33)
    print("ZAPPEDD IT WITH YOURDRAGONXI ", time4xi())    
    print('=' *33) 
                              
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_zap2verb4xi.txt
#   zap-reason-xml files
#
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_zap2verb4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
